"""
Copyright (C) {2015} Texas Instruments Incorporated - http://www.ti.com/ 
ALL RIGHTS RESERVED 
"""

from System.Windows.Media import SolidColorBrush, Color, Colors
from System.Windows.Controls import(ComboBox,ComboBoxItem)
from System.Windows import TextAlignment,FontWeights
import sys
import clr
clr.AddReference("System.Windows.Forms")
from System.Windows.Forms import DialogResult, MessageBox, MessageBoxButtons, MessageBoxIcon
import math


brush_warning = SolidColorBrush(Color.FromArgb(255,204,0,0))
brush_white = SolidColorBrush(Color.FromArgb(255,255,255,255))
brush_alert = SolidColorBrush(Color.FromArgb(255,253,205,52))

text_grey = SolidColorBrush(Color.FromArgb(153,153,153,0))
text_warning = SolidColorBrush(Color.FromArgb(255,204,0,0))
text_black = SolidColorBrush(Colors.Black)

# Note: In some places elements are accessed using UIC_Control (UI Control Element) because of the clash with controls in User Controls Page

    
class GlobalVariables(object):
    def __init__(self):
        self.VCO_freq_state = "";
g = GlobalVariables();

def System_Update():
    UpdateFpdFrequency()
    UpdateVCOFrequency() 
    ValidateFrequencies()

def System_Update_Loaded_Mode():
    Fpd_FREQ_Update()
    UpdateVCOFrequency() 
    ValidateFrequencies()


def System_Update_Run_Once():
    UIC_Fpd_FREQ.TextAlignment = TextAlignment.Left
    #UIC_flexKVCO.TextAlignment = TextAlignment.Left
    UIC_Fvco_FREQ.TextAlignment = TextAlignment.Left       
    UIC_LO_OUT_FREQ.TextAlignment = TextAlignment.Left
    Fpd_FREQ_Update()
    UpdateVCOFrequency() 
    ValidateFrequencies()
    
    #   Update Mixer Stuff
    UIC_flex_MixLO_I.Foreground=text_grey
    UIC_flex_MixLO_I.TextAlignment = TextAlignment.Right
    UIC_flex_MixLO_Q.Foreground=text_grey
    UIC_flex_MixLO_Q.TextAlignment = TextAlignment.Right
    
    #UIC_flex_IFA_GAIN1.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_GAIN2.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_GAIN3.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_GAIN4.TextAlignment = TextAlignment.Left
    
    #UIC_flex_IFA_GAIN1.Foreground = text_grey
    #UIC_flex_IFA_GAIN2.Foreground = text_grey
    #UIC_flex_IFA_GAIN3.Foreground = text_grey
    #UIC_flex_IFA_GAIN4.Foreground = text_grey
      
    #UIC_flex_IFA_BW1.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_BW2.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_BW3.TextAlignment = TextAlignment.Left
    #UIC_flex_IFA_BW4.TextAlignment = TextAlignment.Left  
    
    #UIC_flex_IFA_BW1.Foreground = text_grey
    #UIC_flex_IFA_BW2.Foreground = text_grey
    #UIC_flex_IFA_BW3.Foreground = text_grey
    #UIC_flex_IFA_BW4.Foreground = text_grey    

    #UIC_flex_PullUp1.Foreground = text_grey
    #UIC_flex_PullUp2.Foreground = text_grey     
    
    
    

    
def FCAL_EN_Update():
    if (FCAL_EN.iValue==0):
        UIC_FCAL_EN.Background=brush_alert
    else:
        UIC_FCAL_EN.Background=brush_white
        UIC_FCAL_EN.ToolTip=None
        
def Fosc_FREQ_Update():
    UpdateInputPath()
    
def Fosc_FREQ_Update_UI():
    ValidateFrequencies()

def OSC_2X_Update():
    UpdateInputPath()
    UpdateCurrent()
    
def OSC_2X_Update_UI():
    ValidateFrequencies()
    
def PLL_R_PRE_Update():
    UpdateInputPath()
    UpdateCurrent()

def PLL_R_PRE_Update_UI():
    ValidateFrequencies()
    
def MULT_Update():
    UpdateInputPath()
    UpdateCurrent()
    
def MULT_Update_UI():
    ValidateFrequencies()

def PLL_R_Update():
    UpdateInputPath()
    UpdateCurrent()

def PLL_R_Update_UI():
    ValidateFrequencies()
    
def LO_OUT_FREQ_Update():
    if (flex_ChooseMode.iValue==1):    # this is internal LO mode
        if (LO_OUT_FREQ.dValue>7499.99):
            Fvco_FREQ.dValue=LO_OUT_FREQ.dValue
            LO_DEMUX_DIV2_PD.iValue=1
            LO_DEMUX_POLY_PD.iValue=0
            LO_OUTMUX_DIV2_EN.iValue=0
            LO_OUTMUX_POLY_EN.iValue=1
            LO_INMUX_EXTLO.iValue=0
            LO_INMUX_VCO.iValue=1
            LO_POLY_DRV1_PD.iValue=0
            LO_POLY_NOTCH_PD.iValue=0
            LO_POLY_DRV2_PD.iValue=0
            LO_POLY_PATH_EN.iValue=1
        else:
            Fvco_FREQ.dValue=LO_OUT_FREQ.dValue*2
            LO_DEMUX_DIV2_PD.iValue=0
            LO_DEMUX_POLY_PD.iValue=1
            LO_OUTMUX_DIV2_EN.iValue=1
            LO_OUTMUX_POLY_EN.iValue=0
            LO_INMUX_EXTLO.iValue=0
            LO_INMUX_VCO.iValue=1
            LO_POLY_DRV1_PD.iValue=1
            LO_POLY_NOTCH_PD.iValue=1
            LO_POLY_DRV2_PD.iValue=1
            LO_POLY_PATH_EN.iValue=0
        Fvco_FREQ_Update()
        flex_MixLO_I.dValue=LO_OUT_FREQ.dValue
        flex_MixLO_Q.dValue=LO_OUT_FREQ.dValue

def LO_OUT_FREQ_Update_UI():
    ValidateFrequencies()
       
    
def UpdateInputPath():
    PreR = PLL_R_PRE.iValue
    if (PreR<1):
        PreR=1
    MultOut = Fosc_FREQ.dValue*(OSC_2X.iValue+1)*MULT.iValue/PreR
    if (MultOut<0.000001):
        MultOut = Fosc_FREQ.iValue
        
    Rdiv=PLL_R.iValue
    if (Rdiv<1):
        Rdiv=1

    Fpd_FREQ.dValue=round(MultOut/Rdiv,10)
    UpdateNDivider()
    UpdateVCOFrequency() 

       
def Fpd_FREQ_Update():
    Fpd = Fpd_FREQ.dValue
    if (Fpd<0.000001):
        Fpd=1
    PreR = PLL_R_PRE.iValue
    if (PreR<1):
        PreR=1
    MultOut = Fosc_FREQ.dValue*(OSC_2X.iValue+1)*MULT.iValue/PreR
    if (MultOut<0.000001):
        MultOut = Fosc_FREQ.iValue
        
    Rdiv=MultOut/Fpd
    if Rdiv>128:
        Rdiv=128      
    if Rdiv<1:
        Rdiv=1
    PLL_R.iValue=int(Rdiv+0.5)
    
    UpdateInputPath() 
    UpdateCurrent()

def Fpd_FREQ_Update_UI():
    ValidateFrequencies()
   
def PLL_NUM_Update():
    UpdateVCOFrequency() 
    UpdateCurrent()
    
def PLL_NUM_Update_UI():
    ValidateFrequencies()
    UpdateCurrent()

def PLL_DEN_Update():
    UpdateVCOFrequency() 
    UpdateCurrent()
    
def PLL_DEN_Update_UI():
    ValidateFrequencies()

def PLL_N_Update():
    UpdateVCOFrequency() 
    UpdateCurrent()

def PLL_N_UPdate_UI():
    ValidateFrequencies()
    
def SEG1_EN_Update_UI():
    UpdateCurrent()
    ValidateFrequencies()
    
    
def SYNC_PHASE_MIXLO_Update():
    UpdateIncludedDivide()
    UpdateNDivider() 
    UpdateVCOFrequency()
    UpdateVCOGain() 
    UpdateDistribution()
    
def SYNC_PHASE_MIXLO_Update_UI():
    ValidateFrequencies()   

def SYNC_DRV1_EN_Update_UI():
    ValidateFrequencies()
    
def SYNC_DRV2_EN_Update_UI():
    ValidateFrequencies()    
  
    
def SYNC_PHASE_PLL_Update():
    UpdateIncludedDivide()
    UpdateNDivider() 
    UpdateVCOFrequency()
    UpdateVCOGain() 
    UpdateDistribution()
    
def SYNC_PHASE_PLL_EN_Update_UI():
    ValidateFrequencies()


def VCO_SEL_Update():
    ValidateFrequencies()

def UpdateVCOFrequency():
    Fden=PLL_DEN.iValue
    TotalR=PLL_R_PRE.iValue*PLL_R.iValue
    if (TotalR<1):
        TotalR=1
    TotalMult=(1+OSC_2X.iValue)*MULT.iValue
    if (TotalMult<1):
        TotalMult=1
    #   Be cautions to use calculations that do not cause round-off error problems or VCO frequency
    if (Fden<1):
        Fden=1
    TotalN=1.0*PLL_N.iValue+PLL_NUM.iValue*1.0/Fden
    #Fvco_FREQ.dValue=round(TotalMult*flexINCLUDED_DIVIDE.iValue*TotalN*Fosc_FREQ.dValue/TotalR,10)
    Fvco_FREQ.dValue=round(TotalMult*flexIncludedDivide.iValue*TotalN*Fosc_FREQ.dValue/TotalR,10)
    UpdateVCOGain()
    UpdateDistribution()
    UIC_FCAL_EN.Background=brush_alert
    UIC_FCAL_EN.ToolTip="The FCAL_EN bit needs to be toggled to whenever the VCO frequency is changed to activate the VCO Calibration Sequence."
    pass

def Fvco_FREQ_Update():
    UpdateNDivider() 
    UpdateVCOFrequency()
    UpdateVCOGain() 
    UpdateDistribution()
    UIC_FCAL_EN.Background=brush_alert
    UIC_FCAL_EN.ToolTip="The FCAL_EN bit needs to be toggled to whenever the VCO frequency is changed to activate the VCO Calibration Sequence."
    UpdateCurrent()
   
def Fvco_FREQ_Update_UI():
    ValidateFrequencies()

def UpdateIncludedDivide():
    #   IncludedDivide is one except in the case of SYNC mode with div2
    Divide=1
    
    if (SYNC_PHASE_MIXLO.iValue==1):
        if (SYNC_DRV2_EN.iValue==1) and (LO_OUTMUX_DIV2_EN.iValue==1):
            Divide=2
    elif (SYNC_PHASE_PLL.iValue==1) and (LO_OUT_MUX.iValue==0):
        if (CHDIV.iValue==2) or (CHDIV.iValue==4) or (CHDIV.iValue==8) or (CHDIV.iValue==10) or (CHDIV.iValue==11) or (CHDIV.iValue==15) or (CHDIV.iValue==17):
            Divide=6
        else:
            Divide=4
    
    
        
    flexIncludedDivide.iValue=Divide

def UpdateNDivider():
    Fvco=Fvco_FREQ.dValue
    Fden=PLL_DEN.iValue
    if (Fden<1):
        Fden=1
        PLL_DEN.iValue=1
    Fpd=Fpd_FREQ.dValue
    if (Fpd<0.0000001):
        Fpd_FREQ.dValue=1
        Fpd=1
        
    PreR = PLL_R_PRE.iValue
    if (PreR<1):
        PreR=1
    MultOut = Fosc_FREQ.dValue*(OSC_2X.iValue+1)*MULT.iValue/PreR
    if (MultOut<0.000001):
        MultOut = Fosc_FREQ.iValue
        
    Rdiv=PLL_R.iValue
    if (Rdiv<1):
        Rdiv=1        

    FracN=Rdiv*Fvco/(MultOut*flexIncludedDivide.iValue)
    N=math.floor(FracN)
    PLL_N.iValue=N
    PLL_NUM.iValue=round(Fden*(FracN-N))
    
    pass    
   
def UpdateVCOGain():
    Fvco=Fvco_FREQ.dValue
    
    if (Fvco<7500):
        Kvco = 73
    elif (Fvco<8600):
        Kvco = 73+(114-73)*(Fvco-7500)/(8600-7500)
    elif (Fvco<9800):
        Kvco = 61+(121-61)*(Fvco-8600)/(9800-8600)        
    elif (Fvco<10800):
        Kvco = 98 +(132-98)*(Fvco-9800)/(10800-9800)
    elif (Fvco<12000):
        Kvco = 106 +(141-106)*(Fvco-10800)/(12000-10800)
    elif (Fvco<12900):
        Kvco = 170+(215-170)*(Fvco-12900)/(12900-12000)
    elif (Fvco<13900):
        Kvco = 172+(218-172)*(Fvco-12900)/(13900-12900)
    elif (Fvco<15000):
        Kvco = 182+(239-182)*(Fvco-13900)/(15000-13900)
    else:
        Kvco = 239
    #flexKVCO.dValue=round(Kvco)
    

def ValidateFrequencies():
    Fosc=Fosc_FREQ.dValue
    Fpd =Fpd_FREQ.dValue
    Fvco=Fvco_FREQ.dValue

    #   Validate OSCin
    if (Fosc<5):
        UIC_Fosc_FREQ.Background = brush_warning
        UIC_Fosc_FREQ.ToolTip="Minimum Fosc is 5 MHz"
    elif (Fosc>1400):
        UIC_Fosc_FREQ.Background = brush_warning
        UIC_Fosc_FREQ.ToolTip="Maximum Fosc is 1400 MHz"
    else:
        UIC_Fosc_FREQ.Background = brush_white
        UIC_Fosc_FREQ.ToolTip=None  

    #   Validate OSCin Doubler
    if  (OSC_2X.iValue+1)*Fosc>1400:
        UIC_OSC_2X.Background = brush_warning
        UIC_OSC_2X.ToolTip = "Maximum Input Frequency for the OSCin doubler is 700 MHz."
    else:
        UIC_OSC_2X.Background = brush_white
        
    #   Validate Multiplier  
    PreR=PLL_R_PRE.iValue
    if (0==PreR):
        PreR=1
    MultIn = (OSC_2X.iValue+1)*Fosc/PreR
    MultOut = MultIn*MULT.iValue  
         
    if  (MULT.iValue==1):
        UIC_MULT.Background = brush_white
        UIC_MULT.ToolTip=None
    elif (MULT.iValue==2):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="A Multiply value of 2 is not supported.  However this can be done with the OSCin doubler."
    elif (MULT.iValue>7):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="Multiply Values of greater than 7 are not supported." 
    elif (MultIn<30):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="Minimum input frequency to the Multiplier is 30 MHz"
    elif (MultIn>70):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="Maximum input frequency to the Multiplier is 70 MHz"
    elif (MultOut<180):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="When the multiplier is engaged, the output frequency has to be at least 180 MHz."
    elif (MultOut>250):
        UIC_MULT.Background = brush_warning
        UIC_MULT.ToolTip="When the multiplier is engaged, the output frequency can not be greater than 250 MHz."  
    else:
        UIC_MULT.Background = brush_white
        UIC_MULT.ToolTip=None
    
    #   Validate PostR Divider
    if (MultOut>250) and (PLL_R.iValue>1):
        UIC_PLL_R.Background = brush_warning
        UIC_PLL_R.ToolTip="The PLL_R divider maximum input freqeuncy is 250 MHz.  The PLL_R_PRE divider needs to to reduce this input frequency."
    else:
        UIC_PLL_R.Background = brush_white
        UIC_PLL_R.ToolTip=None
        
    #   Validate FCAL_LPFD_ADJ
    if (Fpd<2.5):
        TargetIndex=3
    elif (Fpd<5):
        TargetIndex=2
    elif (Fpd<10):
        TargetIndex=1
    else:
        TargetIndex=0
         
    if (TargetIndex==FCAL_LPFD_ADJ.iValue):
        UIC_FCAL_LPFD_ADJ.Background=brush_white
        UIC_FCAL_LPFD_ADJ.ToolTip=None
    else:
        UIC_FCAL_LPFD_ADJ.Background=brush_alert
        UIC_FCAL_LPFD_ADJ.ToolTip="Based on the current phase detector frequency of " + str(Fpd)+ " MHz, this should be changed to "+str(TargetIndex)
        
    #   Validate FCAL_HPFD_ADJ
    if (Fpd>200):
        TargetIndex=3
    elif (Fpd>150):
        TargetIndex=2
    elif (Fpd>100):
        TargetIndex=1
    else:
        TargetIndex=0    
    
    if (TargetIndex==FCAL_HPFD_ADJ.iValue):
        UIC_FCAL_HPFD_ADJ.Background=brush_white
        UIC_FCAL_HPFD_ADJ.ToolTip=None
    else:
        UIC_FCAL_HPFD_ADJ.Background=brush_alert
        UIC_FCAL_HPFD_ADJ.ToolTip="Based on the current phase detector frequency of " + str(Fpd)+ " MHz, this should be changed to "+str(TargetIndex)
           
        
    #   Validate CAL_CLK_DIV
    if (Fosc>800):
        TargetIndex=3
    elif (Fosc>400):
        TargetIndex=2
    elif (Fosc>200):
        TargetIndex=1
    else:
        TargetIndex=0   

    if (TargetIndex==CAL_CLK_DIV.iValue):
        UIC_CAL_CLK_DIV.Background=brush_white
        UIC_CAL_CLK_DIV.ToolTip=None
    elif (TargetIndex>CAL_CLK_DIV.iValue):
        UIC_CAL_CLK_DIV.Background=brush_warning
        UIC_CAL_CLK_DIV.ToolTip="Based on the current input frequency of " + str(Fosc)+ " MHz, this should be changed to at least "+str(TargetIndex)
    else:
        UIC_CAL_CLK_DIV.Background=brush_alert
        UIC_CAL_CLK_DIV.ToolTip="Based on the current input frequency of " + str(Fosc)+ " MHz, this VCO calibration time could be reduced by changing this to "+str(TargetIndex)   

        
    #   Check N Divider, Order, and PFD_DLY
    N=PLL_N.iValue
    Order = MASH_ORDER.iValue
    Nmin=1
    PFD_DLYnew=0
    Fvco=Fvco_FREQ.dValue  
    FpdMax=400
    
    #   Validate PLL_N, PFD_DLY, and Fpd
    if (Order==0):
        FpdMax=400
        if (Fvco<12500.00001):
            Nmin=28
            PFD_DLYnew=1
        else:
            Nmin=32
            PFD_DLYnew=2
    elif (Order==1):
        FpdMax=300
        if (Fvco<10000.01):
            Nmin=28
            PFD_DLYnew=1
        elif (Fvco<12500.00001):
            Nmin=32
            PFD_DLYnew=2
        else:
            Nmin=36
            PFD_DLYnew=3
    elif (Order==2):
        FpdMax=300
        if (Fvco<10000.00001):
            Nmin=32
            PFD_DLYnew=2
        else:
            Nmin=36
            PFD_DLYnew=3
    elif (Order==3):
        FpdMax=300
        if (Fvco<10000.00001):
            Nmin=36
            PFD_DLYnew=3
        else:
            Nmin=40
            PFD_DLYnew=4
    elif (Order==4):
        FpdMax=240
        if (Fvco<10000.00001):
            Nmin=44
            PFD_DLYnew=5
        else:
            Nmin=48
            PFD_DLYnew=6
       
    if (N<28):
        UIC_PLL_N.ToolTip="PLL_N values below 28 are not supported."
        UIC_PLL_N.GetTextBox().Background = brush_warning
    elif (N<Nmin):
        UIC_PLL_N.ToolTip="This PLL_N value is too low for this MASH_ORDER, but could be supported if the MASH_ORDER is reduced.\n\n  For this VCO Frequency and MASH_ORDER, the minimum N value is "+str(Nmin)+" and the PFD_DLY_SEL setting should be "+str(PFD_DLYnew)
        UIC_PLL_N.GetTextBox().Background = brush_alert  
    else:
        UIC_PLL_N.ToolTip= None
        UIC_PLL_N.GetTextBox().Background = brush_white      
        
    if (PFD_DLYnew==PFD_DLY_SEL.iValue):
        UIC_PFD_DLY_SEL.GetTextBox().Background=brush_white
        UIC_PFD_DLY_SEL.ToolTip=None
    else:
        UIC_PFD_DLY_SEL.GetTextBox().Background=brush_alert
        UIC_PFD_DLY_SEL.ToolTip="Based on the current phase detector frequency of " + str(Fpd)+ " MHz, this should be changed to "+str(PFD_DLYnew)  
        

    #   Validate Fpd
    if (Fpd_FREQ.dValue>FpdMax):
        UIC_Fpd_FREQ.Background = brush_warning
        UIC_Fpd_FREQ.ToolTip="Maximum Phase Detector Frequency for this MASH_ORDER is "+str(FpdMax)+ " MHz"
    else:
        UIC_Fpd_FREQ.Background = brush_white
        UIC_Fpd_FREQ.ToolTip=None
 
    #   Validate VCO Frequency
    UIC_Fvco_FREQ.Background = brush_white
    UIC_Fvco_FREQ.ToolTip=None
    if (Fvco_FREQ.dValue<7500):
        UIC_Fvco_FREQ.ToolTip="Minimum VCO Frequency is 7.5 GHz"
        UIC_Fvco_FREQ.Background = brush_warning 
    elif (Fvco_FREQ.dValue>15000):
        UIC_Fvco_FREQ.Background = brush_warning
        UIC_Fvco_FREQ.ToolTip="Maximum VCO Frequency is 15 GHz"
               
    #Validate Output Divider
    VCOmax = 100000
    
    if (CHDIV.iValue>2):
        VCOmax=11500
    
    if (Fvco>VCOmax):
        UIC_CHDIV.Background=brush_warning
        UIC_CHDIV.ToolTip = "The maximum VCO frequency for a channel divide of 8 or greater is 11.5 GHz."
    elif (CHDIV.iValue>15) and (SYNC_PHASE_PLL_EN.iValue==1):
        UIC_CHDIV.Background=brush_alert
        UIC_CHDIV.ToolTip = "The phase SYNC for channel divider does not work above a channel divide value of 256"
    else:
        UIC_CHDIV.Background=brush_white
        UIC_CHDIV.ToolTip=None
    
    #   Validate Fout Frequency
    if (LO_OUT_FREQ.dValue > 10000) or (LO_OUT_FREQ.dValue<5000):
        UIC_LO_OUT_FREQ.Background=brush_alert
        UIC_LO_OUT_FREQ.ToolTip="The target spec for output frequency is 5-10 GHz"
    else:
        UIC_LO_OUT_FREQ.Background=brush_white
        UIC_LO_OUT_FREQ.ToolTip=None  
        
    #   Validate Output Chain
    if (LO_INMUX_VCO.iValue+LO_INMUX_EXTLO.iValue==1):
        UIC_LO_INMUX_VCO.Background=brush_white
        UIC_LO_INMUX_VCO.ToolTip=None
        UIC_LO_INMUX_EXTLO.Background=brush_white
        UIC_LO_INMUX_EXTLO.ToolTip=None   
    else:
        UIC_LO_INMUX_VCO.Background=brush_warning
        UIC_LO_INMUX_VCO.ToolTip="The internal and external VCO can not both be seleted as inputs."
        UIC_LO_INMUX_EXTLO.Background=brush_warning
        UIC_LO_INMUX_EXTLO.ToolTip="The internal and external VCO can not both be seleted as inputs."  

    if (LO_DEMUX_POLY_PD.iValue==LO_OUTMUX_POLY_EN.iValue):
        UIC_LO_DEMUX_POLY_PD.Background=brush_warning
        UIC_LO_DEMUX_POLY_PD.ToolTip="LO_DEMUX_POLY_PD and LO_OUTMUX_POLY_EN should have opposite polarity."
        UIC_LO_OUTMUX_POLY_EN.Background=brush_warning
        UIC_LO_OUTMUX_POLY_EN.ToolTip="LO_DEMUX_POLY_PD and LO_OUTMUX_POLY_EN should have opposite polarity."
    else:
        UIC_LO_DEMUX_POLY_PD.Background=brush_white
        UIC_LO_DEMUX_POLY_PD.ToolTip=None
        UIC_LO_OUTMUX_POLY_EN.Background=brush_white
        UIC_LO_OUTMUX_POLY_EN.ToolTip=None
        
    if (LO_POLY_PATH_EN.iValue!=LO_OUTMUX_POLY_EN.iValue):
        UIC_LO_POLY_PATH_EN.Background=brush_warning
        UIC_LO_POLY_PATH_EN.ToolTip="LO_POLY_PATH_EN and LO_OUTMUX_POLY_EN should have same polarity."
    else:
        UIC_LO_POLY_PATH_EN.Background=brush_white
        UIC_LO_POLY_PATH_EN.ToolTip=None    
        

    if (LO_DEMUX_DIV2_PD.iValue==LO_OUTMUX_DIV2_EN.iValue):
        UIC_LO_DEMUX_DIV2_PD.Background=brush_warning
        UIC_LO_DEMUX_DIV2_PD.ToolTip="LO_DEMUX_DIV2_PD and LO_OUTMUX_DIV2_EN should have opposite polarity."
        UIC_LO_OUTMUX_DIV2_EN.Background=brush_warning
        UIC_LO_OUTMUX_DIV2_EN.ToolTip="LO_DEMUX_DIV2_PD and LO_OUTMUX_DIV2_EN should have opposite polarity."
    else:
        UIC_LO_DEMUX_DIV2_PD.Background=brush_white
        UIC_LO_DEMUX_DIV2_PD.ToolTip=None
        UIC_LO_OUTMUX_DIV2_EN.Background=brush_white
        UIC_LO_OUTMUX_DIV2_EN.ToolTip=None 
        
    #   Validate Imbalance due to IQ stages difference
    if (SYNC_DRV1_EN.iValue<>LO_CHDIV_DRV1_EN.iValue):
        UIC_LO_CHDIV_DRV1_EN.Background=brush_alert
        UIC_LO_CHDIV_DRV1_EN.ToolTip="It is recommended to set LO_CHDIV_DRV1_EN=SYNC_DRV1_EN for better IQ balance."
    else:
        UIC_LO_CHDIV_DRV1_EN.Background=brush_white
        UIC_LO_CHDIV_DRV1_EN.ToolTip=None

    if (SYNC_DRV2_EN.iValue<>LO_CHDIV_DRV2_EN.iValue):
        UIC_LO_CHDIV_DRV2_EN.Background=brush_alert
        UIC_LO_CHDIV_DRV2_EN.ToolTip="It is recommended to set SYNC_DRV2_EN=LO_CHDIV_DRV2_EN for better IQ balance."
    else:
        UIC_LO_CHDIV_DRV2_EN.Background=brush_white
        UIC_LO_CHDIV_DRV2_EN.ToolTip=None
            
    #   Validate SYNC
    if (SYNC_DRV1_EN.iValue==0) and (SYNC_PHASE_MIXLO.iValue==1):
        UIC_SYNC_DRV1_EN.Background=brush_warning
        UIC_SYNC_DRV1_EN.ToolTip="SYNC_DRV1_EN should be checked when SYNC_PHASE_MIXLO is checked."
    else:
        UIC_SYNC_DRV1_EN.Background=brush_white
        UIC_SYNC_DRV1_EN.ToolTip=None

    if (SYNC_DRV2_EN.iValue==0) and (SYNC_PHASE_MIXLO.iValue==1):
        UIC_SYNC_DRV2_EN.Background=brush_warning
        UIC_SYNC_DRV2_EN.ToolTip="SYNC_DRV2_EN should be checked when SYNC_PHASE_MIXLO is checked."
    else:
        UIC_SYNC_DRV2_EN.Background=brush_white
        UIC_SYNC_DRV2_EN.ToolTip=None
                
    if (SYNC_PHASE_MIXLO.iValue==1) and (SYNC_PHASE_PLL.iValue==1) and (LO_OUT_MUX.iValue==0) and (LO_OUTMUX_DIV2_EN.iValue==1):
        UIC_LO_OUT_MUX.Background=brush_alert
        UIC_LO_OUT_MUX.ToolTip="You can not SYNC the channel divider and the mixer LO DIV2 at the same time."
    else:
        UIC_LO_OUT_MUX.Background=brush_white
        UIC_LO_OUT_MUX.ToolTip=None
        
def btn_ToggleSyncPin_Update_UI(): 
    UpdateStatusBar("Toggled SYNC Pin") 
    if (GetPin("SYNC")==1):
        SetPin("SYNC",0)
        SetPin("SYNC",1)
    else:
        SetPin("SYNC",1)
        SetPin("SYNC",0)    
def btn_SimplifyFraction_Update_UI():
    Fnum=PLL_NUM.iValue
    Fden=PLL_DEN.iValue
    

    if  ((Fnum==0) or (Fden==0)):
        Fden=1
        Fnum=0
    else:      
        #   Remove 1 for Large Fraction
        if  (Fden>65536) and (Fnum%65536==0) and (Fden%65536==1):
            Fden=Fden-1
            
        Divisor = 2      
        while ( Divisor<Fnum+1):
            if (0 == (Fnum % Divisor)) and (0 == (Fden % Divisor)):
                Fnum=Fnum/Divisor
                Fden=Fden/Divisor
                UpdateStatusBar("Factor of "+str(Divisor))
            else:
                Divisor=Divisor+1
                
        if (Fden%Fnum==0):
            Fden=Fden/Fnum
            Fnum=1
    UpdateStatusBar("Fraction Simplified to "+str(Fnum)+"/"+str(Fden));     
    PLL_DEN.iValue=Fden
    PLL_NUM.iValue=Fnum  
    
def btn_UseLargeFraction_Update_UI():
    if (PLL_NUM.iValue>0) and (PLL_DEN.iValue>0):
        Extend = int(math.log(65536*65536.0/float(PLL_DEN.iValue),2))-1
        if Extend<1:
            Extend=1
        Extend=pow(2,Extend)
        PLL_DEN.iValue=PLL_DEN.iValue*Extend+1
        PLL_NUM.iValue=PLL_NUM.iValue*Extend 


def btn_VCOFASTCAL_Update_UI():
    Fvco=Fvco_FREQ.dValue
    
    VCOmin=7300
    VCOmax=8500
    AmpCalMin=283
    AmpCalMax=232
    CapCtrlMin=183
    CapCtrlMax=0
    AmpCal=260
    VCOSEL=1
    CapCode=78
    
    if (Fvco<8600):
        VCOSEL=1
        VCOmin=7500
        VCOmax=8600
        AmpCalMin=299
        AmpCalMax=240
        CapCtrlMin=164
        CapCtrlMax=12
    elif (Fvco<9800):
        VCOSEL=2
        VCOmin=8600
        VCOmax=9800
        AmpCalMin=356
        AmpCalMax=247
        CapCtrlMin=165
        CapCtrlMax=16
    elif (Fvco<10800):
        VCOSEL=3
        VCOmin=9800
        VCOmax=10800
        AmpCalMin=324
        AmpCalMax=224   
        CapCtrlMin=158
        CapCtrlMax=19        
    elif (Fvco<11900):
        VCOSEL=4 
        VCOmin=10800
        VCOmax=12000
        AmpCalMin=383
        AmpCalMax=244
        CapCtrlMin=140
        CapCtrlMax=0        
    elif (Fvco<12100):
        #   Frequency Hole
        VCOSEL=4
        VCOmin=11900
        VCOmax=12100 
        AmpCalMin=100
        AmpCalMax=100  
        CapCtrlMin=0
        CapCtrlMax=0           
    elif (Fvco<12900):
        VCOSEL=5
        VCOmin=12000
        VCOmax=12900
        AmpCalMin=205
        AmpCalMax=146
        CapCtrlMin=183
        CapCtrlMax=36           
    elif (Fvco<13900):
        VCOSEL=6
        VCOmin=12900
        VCOmax=13900
        AmpCalMin=242
        AmpCalMax=163
        CapCtrlMin=155
        CapCtrlMax=6 
    else:
        VCOSEL=7
        VCOmin=13900
        VCOmax=15000
        AmpCalMin=323
        AmpCalMax=244    
        CapCtrlMin=175
        CapCtrlMax=19       

    CapCode=CapCtrlMin - round( (CapCtrlMin-CapCtrlMax)*(Fvco-VCOmin)/(VCOmax-VCOmin) ,0)
    AmpCal = AmpCalMin+round( (AmpCalMax-AmpCalMin)*(Fvco-VCOmin)/(VCOmax-VCOmin),0 )
    
    if (CapCode<0):
        CapCode=0
    if (CapCode>183):
        CapCode=183
    if (AmpCal<0):
        AmpCal=0
    if (AmpCal>511):
        AmpCal=511
        
    VCO_SEL.iValue=VCOSEL
    VCO_CAPCTRL_STRT.iValue=CapCode
    VCO_DACISET_STRT.iValue=AmpCal
    
def btn_ToggleSyncPin_Update_UI(): 
    UpdateStatusBar("Toggled SYNC Pin") 
    if (GetPin("SYNC")==1):
        SetPin("SYNC",0)
        SetPin("SYNC",1)
    else:
        SetPin("SYNC",1)
        SetPin("SYNC",0)



def CHDIV_Update():
    UpdateDistribution()
    
    if (SYNC_PHASE_PLL.iValue==1):
        UpdateIncludedDivide()
        UpdateNDivider() 
    pass
    
def CHDIV_Update_UI():
    ValidateFrequencies()
    
    

def LO_OUT_MUX_Update_UI():
    ValidateFrequencies() 


def LO_INMUX_VCO_Update():
    UpdateDistribution()
    pass
    
def LO_INMUX_VCO_Update_UI():
    ValidateFrequencies()   
    
def LO_INMUX_EXTLO_Update():
    UpdateDistribution()
    pass
    
def LO_INMUX_EXTLO_Update_UI():
    ValidateFrequencies()    
 
def LO_DEMUX_POLY_PD_Update_UI():
    ValidateFrequencies()      
    
def LO_OUTMUX_POLY_EN_Update():
    UpdateDistribution()
    pass
    
def LO_OUTMUX_POLY_EN_Update_UI():
    ValidateFrequencies() 
    
def LO_POLY_PATH_EN_Update_UI():
    ValidateFrequencies()     
   
def LO_DEMUX_DIV2_PD_Update_UI():
    ValidateFrequencies() 
       
def LO_OUTMUX_DIV2_EN_Update_UI():
    ValidateFrequencies()     
        
def UpdateDistribution():
    Fvco=round(Fvco_FREQ.dValue,10)

    if (LO_DEMUX_DIV2_PD.iValue==1):
        LO_OUT_FREQ.dValue=Fvco
    else:
        LO_OUT_FREQ.dValue=Fvco/2
        
    flex_MixLO_I.dValue=LO_OUT_FREQ.dValue
    flex_MixLO_Q.dValue=LO_OUT_FREQ.dValue
     
def MASH_ORDER_Update_UI():
    ValidateFrequencies()
    
def PFD_DLY_SEL_Update_UI():
    ValidateFrequencies()    
    
def CAL_CLK_DIV_Update_UI():
    ValidateFrequencies()
    
def FCAL_LPFD_ADJ_Update_UI():
    ValidateFrequencies()
    
def FCAL_HPFD_ADJ_Update_UI():
    ValidateFrequencies()
    
def flex_ChooseMode_Update():
    if (flex_ChooseMode.iValue==0):
        UpdateStatusBar(" ")
        UpdateStatusBar("Setting Up for Synthesizer Only Mode")
        UpdateStatusBar("------------------------------------------")
        PLL_PD.iValue=0
        SIGCHAIN_PD.iValue=1
        LO_OUT_PD.iValue=0
        EXTLO_INT_MATCH_RES.iValue=0
        EXTLO_DRV1_EN.iValue=0
        EXTLO_DRV2_EN.iValue=0
    elif (flex_ChooseMode.iValue==1):
        UpdateStatusBar(" ")
        UpdateStatusBar("Setting Up for Internal LO Mode")
        UpdateStatusBar("------------------------------------")
        PLL_PD.iValue=0
        SIGCHAIN_PD.iValue=0
        LO_OUT_PD.iValue=1
        EXTLO_INT_MATCH_RES.iValue=0
        EXTLO_DRV1_EN.iValue=0
        EXTLO_DRV2_EN.iValue=0
        EXTLO_CLK_DRV_EN.iValue=0
        EXTLO_CLK_DIV_EN.iValue=0
        EXTLO_LOW_DRV_EN.iValue=0
        EXTLO_LOW_DUAL_EN.iValue=0
        LO_POLY_CLK_SEL.iValue=0
        LO_INMUX_EXTLO.iValue=0
        LO_INMUX_VCO.iValue=1
        if (LO_OUT_FREQ.dValue>7499.999):
            UpdateStatusBar("->Using Poly Quadrature Generation")
            LO_DEMUX_DIV2_PD.iValue=1
            LO_DEMUX_POLY_PD.iValue=0
            LO_OUTMUX_DIV2_EN.iValue=0
            LO_OUTMUX_POLY_EN.iValue=1
            LO_POLY_DRV1_PD.iValue=0
            LO_POLY_NOTCH_PD.iValue=0
            LO_POLY_DRV2_PD.iValue=0
            LO_POLY_PATH_EN.iValue=1
            LO_POLY_ICH_DRV_PD.iValue=0
            LO_POLY_QCH_DRV_PD.iValue=0
        else:
            UpdateStatusBar("->Using DIV2 Quadrature Generation")
            LO_DEMUX_DIV2_PD.iValue=0
            LO_DEMUX_POLY_PD.iValue=1
            LO_OUTMUX_DIV2_EN.iValue=1
            LO_OUTMUX_POLY_EN.iValue=0
            LO_POLY_DRV1_PD.iValue=1
            LO_POLY_NOTCH_PD.iValue=1
            LO_POLY_DRV2_PD.iValue=1
            LO_POLY_PATH_EN.iValue=0
            LO_POLY_ICH_DRV_PD.iValue=1
            LO_POLY_QCH_DRV_PD.iValue=1
    else:
        UpdateStatusBar(" ")
        UpdateStatusBar("Setting up for External LO Mode")
        UpdateStatusBar("-----------------------------------")
        PLL_PD.iValue=1
        SIGCHAIN_PD.iValue=0
        LO_OUT_PD.iValue=1
        EXTLO_INT_MATCH_RES.iValue=3
        EXTLO_CLK_DRV_EN.iValue=1
        EXTLO_CLK_DIV_EN.iValue=1
        EXTLO_DRV1_EN.iValue=0
        EXTLO_DRV2_EN.iValue=0
        EXTLO_LOW_DRV_EN.iValue=1
        EXTLO_LOW_DUAL_EN.iValue=1
        LO_POLY_CLK_SEL.iValue=0
        LO_INMUX_EXTLO.iValue=1
        LO_INMUX_VCO.iValue=0
        LO_DEMUX_DIV2_PD.iValue=1
        LO_DEMUX_POLY_PD.iValue=0
        LO_POLY_PATH_EN.iValue=1 
        LO_POLY_DRV1_PD.iValue=0
        LO_POLY_NOTCH_PD.iValue=0
        LO_POLY_DRV2_PD.iValue=0
        LO_OUTMUX_DIV2_EN.iValue=0
        LO_OUTMUX_POLY_EN.iValue=1        
    UpdateCurrent()
    
def UpdateCurrent():
    Current3p3V=7
    Current5V=3
    
    if (PLL_PD.iValue==0):
        Current3p3V=Current3p3V+277
        if (LO_OUT_PD.iValue==0):
            Current3p3V=Current3p3V+72
            
    elif (RESET_PLL.iValue==1):
        Current3p3V=Current3p3V+170
        
    if (SIGCHAIN_PD.iValue==0):
        if (LO_OUTMUX_POLY_EN.iValue==1):
            Current3p3V=Current3p3V+399
            Current5V=Current5V+128
        else:
            Current3p3V=Current3p3V+306
            Current5V=Current5V+128

    flexIcc3p3V.dValue=round(Current3p3V)
    flexIcc5V.dValue=round(Current5V)
