"""
Copyright (C) {2015} Texas Instruments Incorporated - http://www.ti.com/ 
ALL RIGHTS RESERVED 
"""

from System.Windows.Media import SolidColorBrush, Color, Colors

from System.Windows.Controls import(ComboBox,ComboBoxItem)
from System.Windows import TextAlignment,FontWeights

import sys
import clr
clr.AddReference("System.Windows.Forms")
from System.Windows.Forms import DialogResult, MessageBox, MessageBoxButtons, MessageBoxIcon

import math


brush_warning = SolidColorBrush(Color.FromArgb(255,204,0,0))
brush_white = SolidColorBrush(Color.FromArgb(255,255,255,255))
brush_alert = SolidColorBrush(Color.FromArgb(255,253,205,52))

text_grey = SolidColorBrush(Color.FromArgb(153,153,153,0))
text_warning = SolidColorBrush(Color.FromArgb(255,204,0,0))
text_black = SolidColorBrush(Colors.Black)

# Note: In some places elements are accessed using UIC_Control (UI Control Element) because of the clash with controls in User Controls Page

    
class GlobalVariables(object):
	def __init__(self):
		self.VCO_freq_state = "";
g = GlobalVariables();



def IFA_GSTATE_Update():
    flex_IFA_GAIN1.iValue=IFA_GSTATE.iValue
    flex_IFA_GAIN2.iValue=IFA_GSTATE.iValue
    flex_IFA_GAIN3.iValue=IFA_GSTATE.iValue
    flex_IFA_GAIN4.iValue=IFA_GSTATE.iValue

    
def IFA_CAP_PROG_Update():
    flex_IFA_BW1.iValue=IFA_CAP_PROG.iValue
    flex_IFA_BW2.iValue=IFA_CAP_PROG.iValue
    flex_IFA_BW3.iValue=IFA_CAP_PROG.iValue
    flex_IFA_BW4.iValue=IFA_CAP_PROG.iValue

 
    
def flex_DesiredVCM_Update():
    UpdateVCM()
    
        
def UpdateVCM():
    VCM = flex_DesiredVCM.dValue
    
    if (flex_DesiredVCM_External.iValue==1):
        VCM_CONFIG.iValue=0
    elif (VCM>1.8):
        VCM = 2.0
        VCM_CONFIG.iValue=2
        flex_DesiredVCM.dValue=VCM
    elif (VCM>1.5):
        VCM = 1.7
        VCM_CONFIG.iValue=4
        flex_DesiredVCM.dValue=VCM
    else:
        VCM = 1.4
        VCM_CONFIG.iValue=8
        flex_DesiredVCM.dValue=VCM
    
    

    if (flex_DesiredVCM.dValue<1.25):
        IFA_PULLUP_EN.iValue=1
        IFA_PULLUP.iValue=7
    elif (flex_DesiredVCM.dValue<1.35):
        IFA_PULLUP_EN.iValue=1
        IFA_PULLUP.iValue=3
    elif (flex_DesiredVCM.iValue<1.45):
        IFA_PULLUP_EN.iValue=1
        IFA_PULLUP.iValue=1
    elif (flex_DesiredVCM.iValue<1.55):
        IFA_PULLUP_EN.iValue=0
        IFA_PULLUP.iValue=0
    else:
        IFA_PULLUP_EN.iValue=0
        IFA_PULLUP.iValue=0       
        

    IFA_IFA_PULLUP_Update()

def UpdateIFA():
    if (flex_IFA_Gain.iValue==4):
        IFA_GSTATE.iValue=15
    elif (flex_IFA_Gain.iValue==1):
        IFA_GSTATE.iValue=1
    elif (flex_IFA_Gain.iValue==2):
        IFA_GSTATE.iValue=3
    elif (flex_IFA_Gain.iValue==3):
        IFA_GSTATE.iValue=7
    else:
        IFA_GSTATE.iValue=0
    
    IFA_GSTATE_Update()   

    if (flex_IFA_BW.iValue==0):
        if (flex_IFA_Gain.iValue==0):
            IFA_CAP_PROG.iValue=9
        else:
            IFA_CAP_PROG.iValue=7+flex_IFA_Gain.iValue
    elif (flex_IFA_BW.iValue==1):
        if (flex_IFA_Gain.iValue<2):
            IFA_CAP_PROG.iValue=2
        elif (flex_IFA_Gain.iValue<4):
            IFA_CAP_PROG.iValue=3
        else:
            IFA_CAP_PROG.iValue=4
    else:
        if (flex_IFA_Gain.iValue==0):
            IFA_CAP_PROG.iValue=7
        else:
            IFA_CAP_PROG.iValue=7+2*flex_IFA_Gain.iValue
            
    IFA_CAP_PROG_Update()
        
def flex_IFA_Gain_Update():
    UpdateIFA()
    
def flex_IFA_BW_Update():
    UpdateIFA()
    